Golf is a programming language and  application server for building web services and back\-end solutions on Linux\. Golf is easy to develop with, memory\-safe and high\-performance\. Read [About Golf](https://golf-lang.com//about-golf.html)\. Visit [Documentation](https://golf-lang.com//documentation.html)\. Try [Hello World](https://golf-lang.com//123-hello-world.html)\. Visit [Golf Blog](https://golf-lang.blogspot.com/) for useful articles and changelog\. Licensed under [Apache 2](https://golf-lang.com//license.html) Free Open Source License\. Source code is at [https://github\.com/golf\-lang/golf](https://github.com/golf-lang/golf)\. Installation packages and source installs below are for both x86\_64 and aarch64\.
## Install Golf on Ubuntu \(versions 20, 22, 24, 25\):
```
sudo add-apt-repository ppa:golf-lang/golf -y
sudo apt update
sudo apt -y install golf
```
You can also [install from source](https://golf-lang.com//install-golf-from-source-using-apt.html)\.
## Install Golf on Redhat \(incl\. Rocky, Alma, Centos\), Fedora, Amazon Linux, Mageia:
```
sudo dnf -y install epel-release
sudo dnf -y copr enable golf-lang/golf-lang
sudo dnf -y install golf
```
You can also [install from source](https://golf-lang.com//install-golf-from-source-using-dnf.html)\.
## Install Golf on OpenSUSE:
Install OpenSUSE Tumbleweed:
```
sudo zypper addrepo https://download.opensuse.org/repositories/home:golf_lang/openSUSE_Tumbleweed/home:golf_lang.repo 
sudo zypper --gpg-auto-import-keys refresh
sudo zypper -n install --replacefiles --force-resolution golf
```
Install OpenSUSE Leap 15\.6:
```
sudo zypper addrepo https://download.opensuse.org/repositories/home:golf_lang/15.6/home:golf_lang.repo 
sudo zypper --gpg-auto-import-keys refresh
sudo zypper -n install --replacefiles --force-resolution golf
```
Install OpenSUSE Slowroll:
```
sudo zypper addrepo https://download.opensuse.org/repositories/home:golf_lang/openSUSE_Slowroll/home:golf_lang.repo 
sudo zypper --gpg-auto-import-keys refresh
sudo zypper -n install --replacefiles --force-resolution golf
```
You can also [install from source](https://golf-lang.com//install-golf-from-source-using-zypper.html)\.
## Install Golf on Debian \(10, 11, 12, Unstable\):
Replace 'Debian\_12' with 'Debian\_10', 'Debian\_11' or 'Debian\_Unstable' to install on Debian 10, 11 or Unstable \(the latest upcoming\):
```
sudo apt install -y curl gpg
echo 'deb http://download.opensuse.org/repositories/home:/golf_lang/Debian_12/ /' | sudo tee /etc/apt/sources.list.d/home:golf_lang.list
curl -fsSL https://download.opensuse.org/repositories/home:golf_lang/Debian_12/Release.key | gpg --dearmor | sudo tee /etc/apt/trusted.gpg.d/home_golf_lang.gpg > /dev/null
sudo apt update
sudo apt install -y golf
```
Install Golf on Debian [from source code](https://golf-lang.com//install-golf-from-source-using-apt.html)\.
## Install Golf on Arch and Manjaro:
```
#Run this one time (to add Golf key):
echo -e "[home_golf_lang_Arch]\nServer = https://download.opensuse.org/repositories/home:/golf_lang/Arch/x86_64" | sudo  tee -a /etc/pacman.conf 
key=$(curl -fsSL https://download.opensuse.org/repositories/home:golf_lang/Arch/$(uname -m)/home_golf_lang_Arch.key)
fingerprint=$(echo "${key}"|gpg --quiet --with-colons --import-options show-only --import --fingerprint  - | awk -F: '$1 == "fpr" { print $10 }')
sudo pacman-key --init
echo "${key}" | sudo pacman-key --add - 
sudo pacman-key --lsign-key "${fingerprint}"
#Install golf going forward
sudo pacman --noconfirm -Sy home_golf_lang_Arch/golf
```
Install Golf on Arch and Manjaro [from source code](https://golf-lang.com//install-golf-from-source-using-pacman.html)\.
## Install Golf on Raspbian \(Raspberry OS\), aarch64 only:
```
sudo apt install -y curl
echo 'deb http://download.opensuse.org/repositories/home:/golf_lang/Raspbian_12/ /' | sudo tee /etc/apt/sources.list.d/home:golf_lang.list
curl -fsSL https://download.opensuse.org/repositories/home:golf_lang/Raspbian_12/Release.key | gpg --dearmor | sudo tee /etc/apt/trusted.gpg.d/home_golf_lang.gpg > /dev/null
sudo apt update
sudo apt -y install golf
```
Install Golf on Raspberry [from source code](https://golf-lang.com//install-golf-from-source-using-apt.html)\.
## Current version
Current version is 520\. This release passed 2392 automated functional tests\.
## Example
Example of Golf code \(from [SaaS example](https://golf-lang.blogspot.com/2024/11/multi-tenant-saas-notes-web-application_43.html)\):
![Golf image](https://golf-lang.com/home-example.png)
## Articles
[Blog](https://golf-lang.blogspot.com/) articles and examples:
* 2025\-05\-03 [Working with debug symbols on Fedora etc\.](https://golf-lang.blogspot.com/2025/05/working-with-debug-symbols-on-fedora-etc.html)
* 2025\-05\-03 [How to install debug symbols for Golf package on Debian/Ubuntu](https://golf-lang.blogspot.com/2025/05/how-to-install-debug-symbols-for-golf.html)
* 2025\-05\-03 [Use case for dnf distro\-sync](https://golf-lang.blogspot.com/2025/05/use-case-for-dnf-distro-sync.html)
* 2025\-04\-25 [Cookies in Golf applications, plus HAProxy\!](https://golf-lang.blogspot.com/2025/04/cookies-in-golf-applications-plus.html)
* 2025\-04\-19 [Example of auto status checking with Golf](https://golf-lang.blogspot.com/2025/04/example-of-auto-status-checking-with.html)
* 2025\-04\-14 [New status\-safety feature](https://golf-lang.blogspot.com/2025/04/new-status-safety-feature.html)
* 2025\-04\-11 [New upcoming safety features](https://golf-lang.blogspot.com/2025/04/safety-improvement-for-application-logic.html)
* 2025\-04\-10 [How to start, stop or restart Golf application server](https://golf-lang.blogspot.com/2025/04/how-to-start-stop-or-restart-golf.html)
* 2025\-04\-05 [How to build OpenSUSE zypper package for Golf](https://golf-lang.blogspot.com/2025/04/how-to-build-opensuse-zypper-package.html)
* 2025\-04\-02 [Fragmentation of Linux and impact on packaging](https://golf-lang.blogspot.com/2025/04/fragmentation-of-linux-and-impact-on.html)
* 2025\-03\-29 [FIFO in Golf](https://golf-lang.blogspot.com/2025/03/fifo-in-golf.html)
* 2025\-03\-23 [How to debug Golf programs with gdb](https://golf-lang.blogspot.com/2025/03/how-to-debug-golf-programs-with-gdb.html)
* 2025\-03\-19 [Maximum file size uploaded to Golf server](https://golf-lang.blogspot.com/2025/03/maximum-file-size-uploaded-to-golf.html)
* 2025\-03\-10 [How to know Golf version](https://golf-lang.blogspot.com/2025/03/how-to-know-golf-version.html)
* 2025\-03\-01 [Web framework for C programming language](https://golf-lang.blogspot.com/2025/03/web-framework-for-c-programming-language.html)
* 2025\-02\-24 [Make RPM package on Fedora and RedHat](https://golf-lang.blogspot.com/2025/02/how-to-create-installation-package-for.html)
* 2025\-02\-23 [DEB package on Ubuntu and Debian](https://golf-lang.blogspot.com/2025/02/create-deb-installation-package-for-golf.html)
* 2025\-02\-21 [34000 requests per second on a modest laptop](https://golf-lang.blogspot.com/2025/02/34000-server-requests-per-second-to.html)
* 2025\-02\-12 [Use C language API to talk to Golf Server](https://golf-lang.blogspot.com/2025/02/use-c-language-api-to-talk-to-golf.html)
* 2025\-02\-04 [Golf package page on AUR for Arch Linux](https://golf-lang.blogspot.com/2025/02/golfs-package-page-on-aur-for-arch-linux.html)
* 2025\-02\-02 [Ubuntu apt package available for Golf](https://golf-lang.blogspot.com/2025/02/ubuntu-apt-package-available-for-golf.html)
* 2025\-01\-30 [How to send email with Golf](https://golf-lang.blogspot.com/2025/01/how-to-send-email-with-golf.html)
* 2025\-01\-28 [Fast JSON parser with little coding](https://golf-lang.blogspot.com/2025/01/fast-json-parser-with-little-coding.html)
* 2025\-01\-03 [What is application server?](https://golf-lang.blogspot.com/2025/01/what-is-application-server_72.html)
* 2024\-12\-26 [Encryption: ciphers, digests, salt, IV](https://golf-lang.blogspot.com/2024/12/encryption-ciphers-digests-salt-iv_84.html)
* 2024\-12\-15 [Distributed computing made easy](https://golf-lang.blogspot.com/2024/12/distributed-computing-made-easy_31.html)
* 2024\-12\-12 [How is memory organized in Golf](https://golf-lang.blogspot.com/2024/12/how-is-memory-organized-in-golf_12.html)
* 2024\-12\-08 [Web file manager in less than 100 lines of code](https://golf-lang.blogspot.com/2024/12/web-file-manager-in-less-than-100-lines_35.html)
* 2024\-12\-02 [Passing parameters between local request handlers](https://golf-lang.blogspot.com/2024/12/passing-parameters-between-local_24.html)
* 2024\-11\-22 [How to create Golf application](https://golf-lang.blogspot.com/2024/11/how-to-create-golf-application_22.html)
* 2024\-11\-21 [Getting help for Golf with man pages](https://golf-lang.blogspot.com/2024/11/getting-help-for-golf-with-man-pages_21.html)
* 2024\-11\-12 [Multi\-tenant SaaS \(Notes web application\) in 200 lines of code](https://golf-lang.blogspot.com/2024/11/multi-tenant-saas-notes-web-application_43.html)
* 2024\-10\-28 [Web Services Security](https://golf-lang.blogspot.com/2024/10/web-services-security_3.html)
* 2024\-10\-21 [Web services with MariaDB](https://golf-lang.blogspot.com/2024/10/web-services-with-mariadb_21.html)
* 2024\-10\-17 [Web service calling web service](https://golf-lang.blogspot.com/2024/10/web-service-calling-web-service_3.html)
* 2024\-10\-13 [What is Web Service](https://golf-lang.blogspot.com/2024/10/what-is-web-service_49.html)
* 2024\-10\-11 [Cache as a web service](https://golf-lang.blogspot.com/2024/10/cache-as-web-service_31.html)
* 2024\-10\-09 [Cache server in 30 lines ](https://golf-lang.blogspot.com/2024/10/cache-server-in-30-lines_9.html)
* 2024\-10\-06 [Memory safety: the cost in performance](https://golf-lang.blogspot.com/2024/10/memory-safety-cost-in-performance_43.html)
* 2024\-09\-29 [SQLite with Golf](https://golf-lang.blogspot.com/2024/09/sqlite-with-golf_29.html)
* 2024\-09\-29 [Copy\-code icon added](https://golf-lang.blogspot.com/2024/09/copy-code-icon-added_61.html)
* 2024\-09\-26 [Overview of Golf](https://golf-lang.blogspot.com/2024/09/overview-of-golf_26.html)
* 2024\-09\-21 [Web service Hello World](https://golf-lang.blogspot.com/2024/09/web-service-hello-world_10.html)
* 2024\-09\-21 [Hello World as a Service](https://golf-lang.blogspot.com/2024/09/hello-world-as-service_60.html)
* 2024\-09\-19 [Using Vim color schemes with Golf](https://golf-lang.blogspot.com/2024/09/using-vim-color-schemes-with-golf_19.html)
* 2024\-09\-17 [Hello World in Golf](https://golf-lang.blogspot.com/2024/09/hello-world-in-golf_17.html)
* 2024\-09\-13 [Introduction to Golf](https://golf-lang.blogspot.com/2024/09/introduction-to-golf_13.html)
* 2024\-09\-12 [Initial Golf release](https://golf-lang.blogspot.com/2024/09/initial-golf-release_12.html)
## Releases
* 2025\-05\-06 [Golf 520 released](https://golf-lang.blogspot.com/2025/05/golf-520-released.html)
* 2025\-05\-02 [Golf 517 released](https://golf-lang.blogspot.com/2025/05/golf-511-released.html)
* 2025\-04\-29 [Golf 501 released](https://golf-lang.blogspot.com/2025/04/golf-492-released.html)
* 2025\-04\-24 [Golf 488 released](https://golf-lang.blogspot.com/2025/04/golf-467-released.html)
* 2025\-04\-23 [Golf 465 released](https://golf-lang.blogspot.com/2025/04/golf-462-released.html)
* 2025\-04\-20 [Golf 452 released](https://golf-lang.blogspot.com/2025/04/golf-426-released.html)
* 2025\-04\-18 [Golf 423 released](https://golf-lang.blogspot.com/2025/04/golf-423-released.html)
* 2025\-04\-17 [Golf 419 released](https://golf-lang.blogspot.com/2025/04/golf-419-released.html)
* 2025\-04\-14 [Golf 397 released](https://golf-lang.blogspot.com/2025/04/golf-397-released.html)
* 2025\-03\-31 [Golf 373 released](https://golf-lang.blogspot.com/2025/03/golf-338-released.html)
* 2025\-03\-16 [Golf 324 released](https://golf-lang.blogspot.com/2025/03/golf-324-released.html)
* 2025\-03\-11 [Golf 297 released](https://golf-lang.blogspot.com/2025/03/golf-297-released.html)
* 2025\-03\-11 [Golf 295 released](https://golf-lang.blogspot.com/2025/03/golf-295-released.html)
* 2025\-03\-10 [Golf 288 released](https://golf-lang.blogspot.com/2025/03/golf-288-released.html)
* 2025\-03\-02 [Golf 273 released](https://golf-lang.blogspot.com/2025/03/golf-273-released.html)
* 2025\-02\-23 [Golf 261 released](https://golf-lang.blogspot.com/2025/02/golf-261-released.html)
* 2025\-02\-19 [Golf 253 released](https://golf-lang.blogspot.com/2025/02/golf-253-released.html)
* 2025\-02\-16 [Golf 247 released](https://golf-lang.blogspot.com/2025/02/golf-247-released.html)
* 2025\-02\-13 [Golf 244 released](https://golf-lang.blogspot.com/2025/02/golf-244-released.html)
* 2025\-02\-11 [Golf 241 released](https://golf-lang.blogspot.com/2025/02/golf-241-released.html)
* 2025\-02\-08 [Golf 231 released](https://golf-lang.blogspot.com/2025/02/golf-231-released.html)
* 2025\-02\-02 [Golf 210 released](https://golf-lang.blogspot.com/2025/02/golf-210-released.html)
* 2025\-01\-27 [Golf 191 released](https://golf-lang.blogspot.com/2025/01/golf-191-released.html)
* 2025\-01\-26 [Golf 184 released](https://golf-lang.blogspot.com/2025/01/golf-184-released.html)
* 2025\-01\-18 [Golf 171 released](https://golf-lang.blogspot.com/2025/01/golf-168-released.html)
* 2025\-01\-14 [Golf 155 released](https://golf-lang.blogspot.com/2025/01/golf-155-released.html)
* 2024\-12\-25 [Golf 136 released](https://golf-lang.blogspot.com/2024/12/golf-136-released_25.html)
* 2024\-12\-24 [Golf 132 released](https://golf-lang.blogspot.com/2024/12/golf-132-released_24.html)
* 2024\-12\-08 [Golf 124 released](https://golf-lang.blogspot.com/2024/12/golf-124-released_8.html)
* 2024\-12\-04 [Golf 121 released](https://golf-lang.blogspot.com/2024/12/golf-121-released_4.html)
* 2024\-11\-29 [Golf 117 released](https://golf-lang.blogspot.com/2024/11/golf-117-released_29.html)
* 2024\-11\-26 [Golf 114 released](https://golf-lang.blogspot.com/2024/11/golf-114-released_26.html)
* 2024\-11\-22 [Golf 109 released](https://golf-lang.blogspot.com/2024/11/golf-109-released_22.html)
* 2024\-11\-10 [Golf 91 released](https://golf-lang.blogspot.com/2024/11/golf-91-released_10.html)
* 2024\-11\-05 [Golf 87 released](https://golf-lang.blogspot.com/2024/11/golf-87-released_5.html)
* 2024\-10\-28 [Golf 76 released](https://golf-lang.blogspot.com/2024/10/golf-76-released_28.html)
* 2024\-10\-23 [Golf 70 released](https://golf-lang.blogspot.com/2024/10/golf-70-released_23.html)
* 2024\-10\-19 [Golf 65 released](https://golf-lang.blogspot.com/2024/10/golf-65-released_19.html)
* 2024\-10\-14 [Golf 56 released](https://golf-lang.blogspot.com/2024/10/golf-56-released_14.html)
* 2024\-10\-08 [Golf 54 released](https://golf-lang.blogspot.com/2024/10/golf-54-released_8.html)
* 2024\-10\-01 [Golf 50 released](https://golf-lang.blogspot.com/2024/10/golf-50-released_1.html)
* 2024\-09\-27 [Golf 44 released](https://golf-lang.blogspot.com/2024/09/golf-44-released_27.html)
* 2024\-09\-24 [Golf 37 released](https://golf-lang.blogspot.com/2024/09/golf-37-released_24.html)
* 2024\-09\-20 [Golf 32 released](https://golf-lang.blogspot.com/2024/09/golf-32-released_20.html)
## Contact
Contact email [team@golf\-lang\.com](mailto:team@golf-lang.com)

Visit [official Golf home page](https://golf-lang.com).

See CONTRIBUTING.md file on how to contribute.

